#include <stdio.h>
#include <string.h>
#include "pcx.h"
#include "editskin.h"
#include "ranges.h"
#include "config.h"

void savebox(pcx_header pcxh)
{
 int x,y;
 char c[2],name[18];
 es_event t;

 for (x=SAVEBOX_PX; x<SAVEBOX_PX+SAVEBOX_SX+1; x++)
  for (y=SAVEBOX_PY; y<SAVEBOX_PY+SAVEBOX_SY+1; y++)
   if (x==SAVEBOX_PX || x==SAVEBOX_PX+SAVEBOX_SX ||
       y==SAVEBOX_PY || y==SAVEBOX_PY+SAVEBOX_SY    )
    es_setpixel(x,y,conf_savebox_fg);
   else
    es_setpixel(x,y,conf_savebox_bg);

 es_setfontcolors(conf_savebox_bg,conf_savebox_fg);
 es_write(SAVEBOX_PX+1,SAVEBOX_PY+2,"Save as:");

 memset(name,0,18);
 
 c[0]=es_getch();
 if (c[0]==27)
 {
  t=es_handler(t);
  if (t.key!=0) c[0]=0;
 }
 c[1]=0;
 x=-1;
 while (c[0]!=10 && c[0]!=27)
 {
  if (x<16 && c[0]!=0) x++;
  if (c[0]==127)
   { 
    if (x>0) x--;
    name[x]=0;
    x--; 
   }
  else
   if (c[0]!=0) name[x]=c[0];
  es_setfontcolors(conf_savebox_bg,conf_savebox_fg);
  es_write(SAVEBOX_PX+1+66,SAVEBOX_PY+2,"                 ");
  es_write(SAVEBOX_PX+1+66,SAVEBOX_PY+2,name);
  c[0]=es_getch();
  if (c[0]==27)
  {
   t=es_handler(t);
   if (t.key!=0) { c[0]=es_getch(); c[0]=0; }
  }
 }

 if (c[0]==27 || strlen(name)==0)
 {
  es_setfontcolors(conf_savebox_bg,conf_savebox_fg);
  es_write(SAVEBOX_PX+1,SAVEBOX_PY+2,"Cancelled...             ");
  sleep(1);
 }
 
 if (c[0]==10 && strcmp(name,"base.pcx")!=0)
 {
  es_setfontcolors(conf_savebox_bg,conf_savebox_fg);
  es_write(SAVEBOX_PX+1,SAVEBOX_PY+2,"Saving...                ");
  write_pcx(name,pcxh,data,palette);
 } else
 if (strcmp(name,"base.pcx")==0)
 {
  es_setfontcolors(conf_savebox_bg,conf_savebox_fg);
  es_write(SAVEBOX_PX+1,SAVEBOX_PY+2,"Can't save as base.pcx   ");
  sleep(1);
 }

 for (x=SAVEBOX_PX; x<SAVEBOX_PX+SAVEBOX_SX+1; x++)
  for (y=SAVEBOX_PY; y<SAVEBOX_PY+SAVEBOX_SY+1; y++)
   es_pixel(x,y);
}